(function ($, Drupal, drupalSettings) {

  'use strict';

  Drupal.behaviors.printjs = {
    attach: function (context, settings) {
      $('.btn-print', context).once('printjs').each(function () {
        init();
      });

      function init() {
        let eventClick = '.btn-print';
        if (drupalSettings.hasOwnProperty('printjs') && drupalSettings.printjs.length && drupalSettings.printjs.printjs_id.length) {
          eventClick += ' ,' + drupalSettings.printjs.printjs_id;
        }

        $(eventClick).on('click', function () {
          let css = [];
          let config = $(this).data();
          $("head").find("link[rel='stylesheet']").attr("href", function (i, value) {
            css.push(value);
            return value;
          });
          config.css = css;
          if (!config.printable.length) {
            config.printable = 'print';
          }
          if (!config.type.length) {
            config.type = 'html';
          }

          if (!$('#' + config.printable).length) {
            if ($('main').length) {
              $('main').attr('id', config.printable);
            } else {
              $('body').attr('id', config.printable);
            }
          }
          // Add print wrapper.
          $('#' + config.printable).wrap('<div class="wrapper-print" id="wrapper-print"></div>');
          // Print parent #print.
          if(drupalSettings.printjs.length && drupalSettings.printjs.print_parent_selector.length){
            config.printable = "wrapper-print";
          }

          if (config.printable) {
            printJS(config);
          } else {
            window.print();
          }
        });
      }
    }
  }
}(jQuery, Drupal, drupalSettings));
