<?php

namespace Drupal\printjs\Plugin\views\area;

use Drupal\Core\Form\FormStateInterface;
use Drupal\views\Plugin\views\area\TokenizeAreaPluginBase;

/**
 * Views area handler for a Printjs button.
 *
 * @ingroup views_area_handlers
 *
 * @ViewsArea("printjs_views_btn")
 */
class PrintjsViewsBtn extends TokenizeAreaPluginBase {

  /**
   * {@inheritdoc}
   */
  public function buildOptionsForm(&$form, FormStateInterface $form_state) {
    parent::buildOptionsForm($form, $form_state);
    $form['printText'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Button text'),
      '#required' => TRUE,
      '#default_value' => $this->options['printText'],
    ];

  }

  /**
   * {@inheritdoc}
   */
  public function render($empty = FALSE) {
    return \Drupal::service('print.js')->getBtnPrintjs($this->options['printText']);
  }

  /**
   * {@inheritdoc}
   */
  protected function defineOptions() {
    $options = parent::defineOptions();
    $options['printText'] = ['default' => t('Print')];
    return $options;
  }

}
