<?php

namespace Drupal\printjs;

/**
 * Service to get button printjs.
 */
class Printjs {

  /**
   * Method get button print js.
   *
   * @param string $printText
   *   Print text.
   *
   * @return array
   *   Return theme.
   */
  public function getBtnPrintjs(string $printText = 'Print') {
    $config = \Drupal::config('printjs.settings');
    $attributes = [
      'class' => [
        'btn-print',
        'btn',
        'btn-success',
      ],
      'data-type' => 'html',
      'data-printable' => 'print',
    ];
    return [
      '#theme' => 'printjs',
      '#printText' => t('@text', ['@text' => $printText]),
      '#attributes' => $attributes,
      '#attached' => [
        'library' => ['printjs/printjs'],
        'drupalSettings' => ['printjs' => $config->getRawData()],
      ],
    ];
  }

}
